/*********************************************************8
Allah RahimKhan J(ARKhan J)
***********************************************************/

#include "stdafx.h"
#include "ExeInside.h"
#include "DependModules.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DependModules dialog
int DependModules::m_ndata = 0;
CString DependModules::m_csData = "";
STATUS_DLL DependModules::status = INIT_DATA;

DependModules::DependModules(CWnd* pParent /*=NULL*/)
	: CDialog(DependModules::IDD, pParent)
{
	//{{AFX_DATA_INIT(DependModules)
	m_csDLLName = _T("");
	m_directory = _T("");
	//}}AFX_DATA_INIT
}


void DependModules::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DependModules)
	DDX_Control(pDX, IDC_COMBO2, m_search);
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Text(pDX, IDC_EDITDLLNAME, m_csDLLName);
	DDX_Text(pDX, IDC_EDITFOLDERNAME, m_directory);
	///}}AFX_DAATA_MAP
}


BEGIN_MESSAGE_MAP(DependModules, CDialog)
	//{{AFX_MSG_MAP(DependModules)
	ON_BN_CLICKED(IDC_BTNDepends, OnBTNDepends)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DependModules message handlers

BOOL DependModules::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here
     m_list.SetExtendedStyle( LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT  );
	m_list.InsertColumn(0,"Count", LVCFMT_LEFT, 50, 300);
	m_list.InsertColumn(1,"Dependent Modules", LVCFMT_LEFT, 250, 250);
	m_search.AddString( "*.exe,*.dll,*.ocx" );
	m_search.AddString( "*.exe" );
	m_search.AddString( "*.dll" );
	m_search.AddString( "*.ocx" );
	m_search.SetCurSel( 1 );
	UpdateData( 1 );
	m_csDLLName = "Kernel32.dll";
	m_directory = "c:\\Windows\\system32";
	UpdateData( 0 );
	//GetListCtrl().InsertColumn(2,"Hint", LVCFMT_LEFT, 70, 100);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

/*************************************
BTN Depends
**************************************/
void DependModules::OnBTNDepends()
{
	try
	{
		m_list.DeleteAllItems();
		UpdateData( 1 );
		CString csSearch;
		int nSel = m_search.GetCurSel();
		CString csDirectory = m_directory +_T( "\\" );
		m_search.GetLBText( nSel, csSearch );
		CString csTotal = csDirectory;
		m_FirstDLL = m_csDLLName;
		int nCount = 0;
		if( "*.exe" == csSearch )
		{
			csTotal += _T( "*.exe" );
		}
		if( "*.dll" == csSearch )
		{
			csTotal += _T( "*.dll" );
		}
		if( "*.ocx" == csSearch )
		{
			csTotal += _T( "*.ocx" );
		}
		if( "*.exe,*.dll,*.ocx" == csSearch )
		{
			csTotal += "*.exe";
			nCount = FindDepends( 0, csTotal );
			csTotal = csDirectory;
			csTotal +="*.dll";
			nCount = FindDepends( nCount, csTotal );
			csTotal = csDirectory;
			csTotal +="*.ocx";
			nCount = FindDepends( nCount, csTotal );
		}
		else
		{
			FindDepends( nCount, csTotal );
		}
	}
	catch( ... )
	{
	}
}
/***************************************************
Find Depends
****************************************************/
int DependModules::FindDepends( int nCount, const CString csSearchCondition_i )
{

	CFileFind ffind;
	BOOL  bWorking = ffind.FindFile( csSearchCondition_i );
	while (bWorking)
	{
		bWorking = ffind.FindNextFile();
		if (ffind.IsDirectory())
		{
			if (ffind.IsDots())
			continue;
		}
		else
		{
			CString csFileName = ffind.GetFileName();
			CString csFullPath  = m_directory;
			csFullPath += _T( "\\" );
			csFullPath += csFileName;
			HMODULE hndMod = 0X0000000;
			GetImport( csFullPath, 1, hndMod );
			FreeLibrary( hndMod );
			if( status == FIND_DLL )
			{
				m_list.InsertItem( nCount, 0 );
				CString csFormat;
				csFormat.Format( "%d", nCount );
				m_list.SetItemText( nCount, 0, csFormat );
				m_list.SetItemText( nCount, 1, csFileName );
				nCount++;
			}
			status = INIT_DATA;
		}
	}
	return nCount;
}

void DependModules::GetImport( CString csPath )
{
	HMODULE hMod;
    bool bStatus = GetDLLLoadAddress(  csPath,  hMod  );
	if(!bStatus )
	{
		return;
	}
	IMAGE_DOS_HEADER* IDH = (IMAGE_DOS_HEADER*)hMod;
	IMAGE_OPTIONAL_HEADER* IOH = (IMAGE_OPTIONAL_HEADER*)((BYTE*)hMod + IDH->e_lfanew + 24);
	// Export table
	char* szDllName2;
	// Import table
	IMAGE_IMPORT_DESCRIPTOR* IID = (IMAGE_IMPORT_DESCRIPTOR*)((BYTE*)hMod + IOH->DataDirectory[ IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);

	int nID = 1;
	while(IID->FirstThunk)
	{
		szDllName2 = (char*)((BYTE*)hMod+IID->Name);
		IMAGE_THUNK_DATA* ITD =(IMAGE_THUNK_DATA*)((BYTE*)hMod+ IID->OriginalFirstThunk);

		if( FALSE != IsBadReadPtr( ITD, sizeof( IMAGE_THUNK_DATA )))
		{
			//DeleteString( "ntdll.dll");
			return;
		}
		// Add the string....
		if( AddString( szDllName2 ))
		{
			GetImport( szDllName2 );
		}
		IID++;
		DeleteString( szDllName2 );
	}

	return;
}


STATUS_DLL DependModules::GetImport( CString csPath, int nData, HMODULE& hModReturn  )
{
	if( 1 != nData )
	{
		return NOTFOUND;
	}

	HMODULE hMod;
	//hMod = LoadLibrary( csPath );
    bool bStatus = GetDLLLoadAddress(  csPath,  hMod  );
	hModReturn = hMod;
	if(!bStatus )
	{
		return NOTFOUND;
	}
	IMAGE_DOS_HEADER* IDH = (IMAGE_DOS_HEADER*)hMod;
	IMAGE_OPTIONAL_HEADER* IOH = (IMAGE_OPTIONAL_HEADER*)((BYTE*)hMod + IDH->e_lfanew + 24);
	// Export table
	char* szDllName2;
	// Import table
	IMAGE_IMPORT_DESCRIPTOR* IID = (IMAGE_IMPORT_DESCRIPTOR*)((BYTE*)hMod + IOH->DataDirectory[ IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);

	int nID = 1;
	while(IID->FirstThunk)
	{
		szDllName2 = (char*)((BYTE*)hMod+IID->Name);
		IMAGE_THUNK_DATA* ITD =(IMAGE_THUNK_DATA*)((BYTE*)hMod+ IID->OriginalFirstThunk);

		if( FALSE != IsBadReadPtr( ITD, sizeof( IMAGE_THUNK_DATA )))
		{
			return INIT_DATA;
		}
		if( status == FIND_DLL )
		{
			return FIND_DLL;
		}
		CString csDLLNAME = szDllName2;
		m_FirstDLL.MakeUpper();
        csDLLNAME.MakeUpper();
		m_FirstDLL.Remove( ' ' );
		if( m_FirstDLL == csDLLNAME )
		{
			status = FIND_DLL;
			return FIND_DLL;
		}

		// Add the string....
		if( AddString( szDllName2, true ))
		{
			HMODULE hndMod = 0X000000;
			GetImport( szDllName2, 1, hndMod );
		}
		IID++;
		DeleteString( szDllName2 );
	}

	return INIT_DATA;

}


bool DependModules::AddString( CString csData, bool bNoTree )
{
	DependModules::m_ndata++;
	if( 1 >= DependModules::m_ndata)
	{

			m_csData = "";
			m_csData += "\\";
			m_csData += csData;
			CString csUpper = m_csData;
		if( !bNoTree )
		{
			csUpper.MakeUpper();
			m_obj.InsertNode( csUpper );
		}
		return true;
	}
	else
	{
		int nPos= 0;
		int nSize = 0;
		if( -1 == m_csData.Find( csData, 0 ))
		{
			m_csData += "\\";
			m_csData += csData;
			CString csUpper = m_csData;
			if( !bNoTree )
			{
				csUpper.MakeUpper();
				m_obj.InsertNode( csUpper );
			}
			return true;
		}
		else
		{
			m_csData += "\\";
			m_csData += csData;
			CString csUpper = m_csData;
			if( !bNoTree )
			{
				csUpper.MakeUpper();
				m_obj.InsertNode( csUpper );
			}
			return false;
		}
	}
}

bool DependModules::DeleteString( CString csData )
{
	CString csStr;
	csStr += "\\";
	csStr += csData;
	int nData = m_csData.ReverseFind( '\\');
	int nFinalLength = nData + csData.GetLength();
	int Totak = m_csData.GetLength();
	if( nFinalLength ==  Totak - 1)
	{
		m_csData = m_csData.Mid( 0, nData );
		DependModules::m_ndata--;
	}
	else
	{
		return false;
	}
	return true;
}


bool DependModules::GetDLLLoadAddress(  CString csDLLName,  HMODULE& hModDLL  )
{
	if( -1 != csDLLName.Find( "\\", 0 ))
	{
		HANDLE hCurrentFile = CreateFile( csDLLName, GENERIC_READ,
										  FILE_SHARE_READ,NULL,
										  OPEN_EXISTING,
										  FILE_ATTRIBUTE_NORMAL,
										  NULL );
		if( INVALID_HANDLE_VALUE != hCurrentFile )
		{
			hModDLL = LoadLibraryEx( csDLLName, NULL, DONT_RESOLVE_DLL_REFERENCES );
			if( 0 != hModDLL )
			{
				return true;
			}
			else
			{
				return false;
			}
		}
	}

	CString csPath;
	CString csFileName = "\\";
	csFileName += csDLLName;
	DWORD nNum;
	nNum = GetCurrentDirectory( MAX_PATH,csPath.GetBuffer(MAX_PATH));
	csPath.ReleaseBuffer();
	csPath += csFileName;
	HANDLE hFile = CreateFile( csPath, GENERIC_READ,
							   FILE_SHARE_READ,NULL,
							   OPEN_EXISTING,
							   FILE_ATTRIBUTE_NORMAL,
							   NULL );
	if( INVALID_HANDLE_VALUE == hFile )
	{
		CString csData = _tgetenv( _T( "Path" ));
		int nIndex = 0;
		int nPrev = 0;
		csData.Remove( ' ' );
		csPath = "";

		while( -1 !=( nIndex =  csData.Find( ";", nIndex )))
		{
			csPath = csData.Mid( nPrev, ( nIndex - nPrev ));
			csPath += csFileName;
			BOOL m_bLoaded = FALSE;
			HANDLE hFile = CreateFile( csPath, GENERIC_READ,
								       FILE_SHARE_READ,NULL,
								       OPEN_EXISTING,
								       FILE_ATTRIBUTE_NORMAL,
								       NULL );
			if( INVALID_HANDLE_VALUE != hFile )
			{
				break;
			}
			nPrev = ++nIndex;
		}
	}
	hModDLL = LoadLibraryEx( csPath, NULL, DONT_RESOLVE_DLL_REFERENCES );
	if( 0 != hModDLL )
	{
		return true;
	}
	else
	{
		return false;
	}
}

