// DependencyTreeView.cpp : implementation file
//

#include "stdafx.h"
#include "ExeInside.h"
#include "DependencyTreeView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDependencyTreeView

IMPLEMENT_DYNCREATE(CDependencyTreeView, CTreeView)

CDependencyTreeView::CDependencyTreeView()
{
}

CDependencyTreeView::~CDependencyTreeView()
{
}


BEGIN_MESSAGE_MAP(CDependencyTreeView, CTreeView)
	//{{AFX_MSG_MAP(CDependencyTreeView)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDependencyTreeView drawing

void CDependencyTreeView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CDependencyTreeView diagnostics

#ifdef _DEBUG
void CDependencyTreeView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CDependencyTreeView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG



CPEWatcherDoc* CDependencyTreeView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPEWatcherDoc)));
	return (CPEWatcherDoc*)m_pDocument;
}

/////////////////////////////////////////////////////////////////////////////
// CDependencyTreeView message handlers

void CDependencyTreeView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();
	PEFormatParser obj;
	TreeR objTree;
	if( FALSE == GetDocument()->m_csFileName.IsEmpty())
	{
		objTree = obj.GetTreeNode( GetDocument()->m_csFileName );
		GetDocument()->SetMapdata( obj.m_DataEntry );
	}
	long lStyle = GetWindowLong( m_hWnd, GWL_STYLE );
	lStyle = WS_VISIBLE | WS_TABSTOP | WS_CHILD | WS_BORDER
   | TVS_HASBUTTONS | TVS_LINESATROOT | TVS_HASLINES
   |  TVS_EDITLABELS;

	::SetWindowLong( m_hWnd, GWL_STYLE, lStyle );
//	HICON hIcon = (HICON) LoadImage( AfxGetInstanceHandle(),
//		MAKEINTRESOURCE( IDI_ICON1 ), IMAGE_ICON, 48, 48, 0 );
	m_ImageList.Create( IDB_BITMAP2, 16, 1, RGB (255, 0, 255));
	GetTreeCtrl().SetImageList( &m_ImageList, TVSIL_NORMAL );

	AddToTree(objTree);

}

void CDependencyTreeView::AddToTree(TreeR pObj)
{
	GetTreeCtrl().DeleteAllItems();
	TNode* pCurrent = pObj.GetNode();
	HTREEITEM  HITCtem;
	if( 0 != pCurrent )
	{
		TNode* pLastNode = pCurrent;
		int nIDX = 0;
		while( 0 != pLastNode->pTreeNode[nIDX])
		{
			HTREEITEM HStepItem = GetTreeCtrl().InsertItem(
				pLastNode->pTreeNode[nIDX]->csNodeData,
				0, 0 );
			GetTreeNode(pLastNode->pTreeNode[nIDX], HStepItem);
			delete pLastNode->pTreeNode[nIDX];
			nIDX++;
		}
	}
}

void CDependencyTreeView::GetTreeNode(TNode* pNode_i, HTREEITEM HStepItem )
{
	int nIDX = 0;
	TNode* pNode = pNode_i;
	int nData = 0;
	int ndata1 = 0;
	LOGFONT lf;

	while( 0 != pNode->pTreeNode[nIDX])
	{
		SingleMapEntryArray Entryexport;
		int nStab = 2;
		if( GetDocument()->GetExportData(pNode->pTreeNode[nIDX]->csNodeData, Entryexport ))
		{
			nStab = GetDocument()->GetDLLStability();
		}

		nData = 1;
		ndata1 = 1;
		if( 3 == nStab )
		{
			nData = 3;
			ndata1 = 3;
		}
		if( 2 == nStab )
		{
			nData = 2;
			ndata1 = 2;
		}
		HTREEITEM HItem = GetTreeCtrl().InsertItem( pNode->pTreeNode[nIDX]->csNodeData,
			                                nData, ndata1, HStepItem );
		GetTreeNode( pNode->pTreeNode[nIDX], HItem);
		delete pNode->pTreeNode[nIDX];
		nIDX++;
	}
}


void CDependencyTreeView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult)
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	HTREEITEM hCurSel = GetTreeCtrl().GetNextItem(TVI_ROOT, TVGN_CARET  );
	SetFileName( GetTreeCtrl().GetItemText( hCurSel ));
	GetDocument ()->UpdateAllViews (this, UPDATE_EXPORT_IMPORT );
	*pResult = 0;
}


