// ExportListView.cpp : implementation file
//

#include "stdafx.h"
#include "ExeInside.h"
#include "ExportListView.h"
#include "DependencyTreeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExportListView

IMPLEMENT_DYNCREATE(CExportListView, CListView)

CExportListView::CExportListView()
{
}

CExportListView::~CExportListView()
{
}


BEGIN_MESSAGE_MAP(CExportListView, CListView)
	//{{AFX_MSG_MAP(CExportListView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExportListView drawing

void CExportListView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}


CPEWatcherDoc* CExportListView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPEWatcherDoc)));
	return (CPEWatcherDoc*)m_pDocument;
}

/////////////////////////////////////////////////////////////////////////////
// CExportListView diagnostics

#ifdef _DEBUG
void CExportListView::AssertValid() const
{
	CListView::AssertValid();
}

void CExportListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CExportListView message handlers

void CExportListView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();
	GetListCtrl().SetExtendedStyle( LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT  );
	GetListCtrl().InsertColumn(0,"Count", LVCFMT_LEFT, 50, 100);
	GetListCtrl().InsertColumn(1,"Export-Ordinal", LVCFMT_LEFT, 85, 100);
	GetListCtrl().InsertColumn(2,"Hint", LVCFMT_LEFT, 70, 100);
	GetListCtrl().InsertColumn(3,"Exported-Function Names", LVCFMT_LEFT, 145, 100);
	GetListCtrl().InsertColumn(4,"Entry Point", LVCFMT_LEFT, 80, 100);

}

BOOL CExportListView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style &= ~LVS_TYPEMASK;
    cs.style |= LVS_REPORT;
	return CListView::PreCreateWindow(cs);
}



void CExportListView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	if( UPDATE_EXPORT_IMPORT == lHint )
	{
		GetListCtrl().DeleteAllItems();
		CDependencyTreeView* pTreeView = (CDependencyTreeView*)pSender;
		CString csName = pTreeView->GetFileName();

		if( 0 != GetDocument()->GetExportData( csName, m_Entryexport ))
		{
			int nSize = m_Entryexport.GetSize();
			int nIndex = 0;
			while( nIndex < nSize )
			{
				GetListCtrl().InsertItem( nIndex,0 );
				//ListView_SetItemText( GetListCtrl().m_hWnd, nIndex, 0,
				//	                  const_cast<LPTSTR>(m_Entryexport.GetAt( nIndex).csIndex.operator LPCTSTR()));
				GetListCtrl().SetItemText( nIndex, 0,
				m_Entryexport.GetAt( nIndex).csIndex );
				//::SendMessage( GetListCtrl().m_hWnd, LVM_SETITEMTEXT, (WPARAM)nIndex,
				//	LPARAM(m_Entryexport.GetAt( nIndex).csIndex.operator LPCTSTR()));
				GetListCtrl().SetItemText( nIndex, 1,
				m_Entryexport.GetAt( nIndex).csOrdinal );
				GetListCtrl().SetItemText( nIndex, 2,
				m_Entryexport.GetAt( nIndex).csHint );
				GetListCtrl().SetItemText( nIndex, 3,
				m_Entryexport.GetAt( nIndex).csFunction );
				GetListCtrl().SetItemText( nIndex, 4,
				m_Entryexport.GetAt( nIndex).csEntryPoint );
				nIndex++;
			}
		}
	}


}


UINT CExportListView::UpdateListCtrl( LPVOID lpData )
{
	HANDLE hnd1,hnd2;
	hnd1 = OpenEvent( EVENT_ALL_ACCESS, FALSE, _T( "Name1" ));
	CExportListView* pExport = reinterpret_cast<CExportListView*>(lpData);
	int nSize = pExport->m_Entryexport.GetSize();
	int nIndex = 0;
	while( nIndex < nSize )
	{
		pExport->GetListCtrl().InsertItem( nIndex,0 );
		pExport->GetListCtrl().SetItemText( nIndex, 0,
			pExport->m_Entryexport.GetAt( nIndex).csIndex );
		pExport->GetListCtrl().SetItemText( nIndex, 1,
			pExport->m_Entryexport.GetAt( nIndex).csOrdinal );
		pExport->GetListCtrl().SetItemText( nIndex, 2,
			pExport->m_Entryexport.GetAt( nIndex).csHint );
		pExport->GetListCtrl().SetItemText( nIndex, 3,
			pExport->m_Entryexport.GetAt( nIndex).csFunction );
		pExport->GetListCtrl().SetItemText( nIndex, 4,
			pExport->m_Entryexport.GetAt( nIndex).csEntryPoint );
		nIndex++;
	}
	return 1;
}
