// ImportListView.cpp : implementation file
//

#include "stdafx.h"
#include "ExeInside.h"
#include "ImportListView.h"
#include "DependencyTreeView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CImportListView


IMPLEMENT_DYNCREATE(CImportListView, CListView)

CImportListView::CImportListView()
{
}

CImportListView::~CImportListView()
{
}


BEGIN_MESSAGE_MAP(CImportListView, CListView)
	//{{AFX_MSG_MAP(CImportListView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CImportListView drawing

void CImportListView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CImportListView diagnostics

#ifdef _DEBUG
void CImportListView::AssertValid() const
{
	CListView::AssertValid();
}

void CImportListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG


CPEWatcherDoc* CImportListView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPEWatcherDoc)));
	return (CPEWatcherDoc*)m_pDocument;
}

/////////////////////////////////////////////////////////////////////////////
// CImportListView message handlers

void CImportListView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();
	GetListCtrl().SetExtendedStyle( LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT | LVS_EX_SUBITEMIMAGES );
	GetListCtrl().InsertColumn(0,"Count", LVCFMT_LEFT, 50, 100);
	GetListCtrl().InsertColumn(1,"Import-Ordinal", LVCFMT_LEFT, 85, 100);
	GetListCtrl().InsertColumn(2,"Hint", LVCFMT_LEFT, 70, 100);
	GetListCtrl().InsertColumn(3,"Imported-Function Names", LVCFMT_LEFT, 145, 100);
	GetListCtrl().InsertColumn(4,"Entry Point", LVCFMT_LEFT, 80, 100);
}

BOOL CImportListView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style &= ~LVS_TYPEMASK;
    cs.style |= LVS_REPORT;
	return CListView::PreCreateWindow(cs);
}

void CImportListView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	if( UPDATE_EXPORT_IMPORT == lHint )
	{
		GetListCtrl().DeleteAllItems();
		CDependencyTreeView* pTreeView = (CDependencyTreeView*)pSender;
		CString csName = pTreeView->GetFileName();

		if( 0 != GetDocument()->GetImportData(csName, m_Entryimport ))
		{
			int nSize = m_Entryimport.GetSize();
			int nIndex = 0;
			while( nIndex < nSize )
			{
				if( m_Entryimport.GetAt( nIndex).m_bIsInvalidValid )
				{
					GetListCtrl().SetTextColor( RGB(230,0,0) );
				}
				else
				{
					GetListCtrl().SetTextColor( RGB(0,0,0));
				}
				GetListCtrl().InsertItem( nIndex,0 );
				GetListCtrl().SetItemText( nIndex, 0,
				m_Entryimport.GetAt( nIndex).csIndex );
				GetListCtrl().SetItemText( nIndex, 1,
				m_Entryimport.GetAt( nIndex).csOrdinal );
				GetListCtrl().SetItemText( nIndex, 2,
				m_Entryimport.GetAt( nIndex).csHint );
				GetListCtrl().SetItemText( nIndex, 3,
				m_Entryimport.GetAt( nIndex).csFunction );
				GetListCtrl().SetItemText( nIndex, 4,
				m_Entryimport.GetAt( nIndex).csEntryPoint );
				nIndex++;
			}
		}
	}
}


