#include "stdAfx.h"
#include "PEFormatParser.h"


int PEFormatParser::m_ndata = 0;
CString PEFormatParser::m_csdata = "";


TreeR PEFormatParser::GetTreeNode( LPCTSTR lpctszModName_i )
{
	m_csdata = "";
	m_ndata = 0;
	m_MapExport.InitHashTable( 5000, TRUE );
	int nSize = CString(lpctszModName_i).ReverseFind( '\\');
	m_csFirstDLL = CString(lpctszModName_i).Mid( nSize + 1, 
		   ( CString(lpctszModName_i).GetLength() - nSize ));
	m_csCurrentDirectory = lpctszModName_i;
	m_csCurrentDirectory.Replace( m_csFirstDLL, "" );
	AddString( m_csFirstDLL );
	SingleMapEntryArray csExportArr;
	CString csPath;
	GetExportData( lpctszModName_i, csExportArr, csPath );
	SINGLE_FUNCT_ENTRY newElement;
	DLL_ENTRY stImpExport;
	stImpExport.ArrayExport.Copy( csExportArr );
	stImpExport.m_csFullPath = csPath;
	m_csFirstDLL.MakeUpper();
	m_DataEntry.SetAt( m_csFirstDLL, stImpExport );
	GetImportAndExportData( lpctszModName_i );
	return m_Treeobj;
}


void PEFormatParser::GetImportAndExportData( LPCTSTR lpctszModName_i )
{
	if( FALSE != CString(lpctszModName_i).IsEmpty())
	{
		return;
	}
	HMODULE hMod;
	CString csPath;
    bool bStatus = GetDLLLoadAddress(  lpctszModName_i,  hMod, csPath  );
	// Import table
	char* szDllName2;
	char* szFunctionName2;
	int nID = 1;
	IMAGE_DOS_HEADER* IDH = (IMAGE_DOS_HEADER*)hMod;
	if( 0 == IDH)
	{
		return;
	}
	IMAGE_OPTIONAL_HEADER* IOH = 
	(IMAGE_OPTIONAL_HEADER*)((BYTE*)hMod + IDH->e_lfanew + 24);
	if( 0 == IOH)
	{
		return;
	}
	IMAGE_IMPORT_DESCRIPTOR* IID = 
			(IMAGE_IMPORT_DESCRIPTOR*)((BYTE*)hMod + IOH->DataDirectory[ IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);
	if( 0 == IID )
	{
		return;
	}
	CString csData;
	while(IID->FirstThunk)
	{
		szDllName2 = (char*)((BYTE*)hMod+IID->Name); 
		bool bIsStable = true;
		csData = szDllName2;
		IMAGE_THUNK_DATA* ITD =(IMAGE_THUNK_DATA*)((BYTE*)hMod+ IID->OriginalFirstThunk);

		if( FALSE != IsBadReadPtr( ITD, sizeof( IMAGE_THUNK_DATA )))
		{
			return;
		}
		if( AddString( szDllName2 ))
		{
		}
		SingleMapEntryArray csExportArr;
		SingleMapEntryArray csImportArr;
		CString csPath;
		if( 0 == CString(szDllName2).CompareNoCase( "oleaut32.dll") )
		{
			int n;
			int j = n+1;
		}
		GetExportData( szDllName2, csExportArr, csPath );
		int nIndex = 1;
		while(ITD->u1.Function)
		{
			szFunctionName2 =  (char*)((BYTE*)hMod + (DWORD)ITD->u1.AddressOfData+2);

			CString csFunctioname = szFunctionName2;
			IMAGE_IMPORT_BY_NAME* pImportByName = (IMAGE_IMPORT_BY_NAME*)((BYTE*)hMod + ITD->u1.AddressOfData);
			if( FALSE != csFunctioname.IsEmpty())
			{
				if(0 == IsBadReadPtr(pImportByName,sizeof(IMAGE_IMPORT_BY_NAME)))
				{
					ITD++;
				}
				else
				{
					SINGLE_FUNCT_ENTRY newElement;
					pImportByName = (IMAGE_IMPORT_BY_NAME*)(ITD);
					CString csFormat;
					CString csOrdinal;
					csOrdinal.Format( "%d(0X%x)",pImportByName->Hint, 
						              pImportByName->Hint );
					csOrdinal.MakeUpper();
					csOrdinal.Replace( 'X','x');
					DWORD dwref = 2147490110 - (DWORD)ITD->u1.AddressOfData;
					newElement.csOrdinal.Format( "%s", csOrdinal );
					newElement.csEntryPoint.Format( "0x%x", dwref );
					newElement.csEntryPoint.MakeUpper();
					newElement.csEntryPoint.Replace( 'X','x');
					newElement.csHint = "N/A";
					newElement.csFunction = "N/A";
					newElement.csIndex.Format("%d", nIndex);
					csImportArr.Add( newElement );
					newElement.m_bIsInvalidValid = false;
					pImportByName++;
				}
			}
			else
			{
				SINGLE_FUNCT_ENTRY newElement;
				newElement.csFunction = csFunctioname;
				CString csFormat;
				CString csOrdinal;
				csOrdinal.Format( "%d(0X%x)",pImportByName->Hint, 
								  pImportByName->Hint );
				csOrdinal.MakeUpper();
				csOrdinal.Replace( 'X','x');
				newElement.csHint = "N/A";
				newElement.csOrdinal = "N/A";
				
				newElement.csHint.Format( "%s", csOrdinal );
				newElement.csEntryPoint.Format( "NB" );
				int nSearchVal;
				if( FALSE == m_MapExport.Lookup( csFunctioname, nSearchVal ))
				{
					bIsStable = false;
					newElement.m_bIsInvalidValid = true;
				}
				else
				{
					bIsStable = true;
					newElement.m_bIsInvalidValid = false;
				}
				newElement.csIndex.Format("%d", nIndex);
				csImportArr.Add( newElement );
			}
			ITD++;
			nIndex++;
		}
		DLL_ENTRY stImpExport;
		if( !bIsStable )
		{
			stImpExport.m_bIsStable = false;
		}
		else
		{
			stImpExport.m_bIsStable = true;
		}
		stImpExport.ArrayExport.Copy( csExportArr );
		stImpExport.ArrayImport.Copy( csImportArr );
		stImpExport.m_csFullPath = csPath;
		csData.MakeUpper();
		m_DataEntry.SetAt( csData, stImpExport );
		stImpExport.m_bIsStable = true;
		bIsStable = true;
		IID++;
		DeleteString( szDllName2 );
	}
	int nCount = m_DataEntry.GetCount();
	m_MapExport.RemoveAll();
}


void PEFormatParser::GetExportData( LPCTSTR lpctszDLLName_i, 
								    SingleMapEntryArray& ExportEntriesArr,
									CString& csPath_o )
{
	m_MapExport.RemoveAll();
	HMODULE hMod;
	CString csPath;
    bool bStatus = GetDLLLoadAddress(  lpctszDLLName_i,  hMod, csPath );
	csPath_o = csPath;
	if(!bStatus )
	{
		return;
	}
	IMAGE_DOS_HEADER* IDH = (IMAGE_DOS_HEADER*)hMod;
	IMAGE_OPTIONAL_HEADER* IOH = (IMAGE_OPTIONAL_HEADER*)((BYTE*)hMod + IDH->e_lfanew + 24);
	_IMAGE_EXPORT_DIRECTORY* pExportDescriptor = 
		(_IMAGE_EXPORT_DIRECTORY*)((BYTE*)hMod + IOH->DataDirectory[IMAGE_DIRECTORY_ENTRY_EXPORT].VirtualAddress);
	int  nSize = pExportDescriptor->Name;
	BYTE* pName = 0;
	CString csName;
	LPSTR name = 0;
	int nData = 0;
	bool bIntial = true;
	CString csType;
	unsigned long ulbase = pExportDescriptor->Base - 1;
	DWORD dwData = pExportDescriptor->AddressOfFunctions;
	SINGLE_FUNCT_ENTRY SingleEntry;
	int nHint = -2;
	while( nData <= pExportDescriptor->NumberOfFunctions )
	{ 
		DWORD dwData =  pExportDescriptor->AddressOfNameOrdinals;
		if( 0 == pExportDescriptor->NumberOfNames )
		{
			if(bIntial)
			{
				bIntial = false;
			}
			else
			{
				CString csOrdinal;
				csOrdinal.Format( "%d(0X%x)",ulbase, ulbase );
				csOrdinal.MakeUpper();
				csOrdinal.Replace( 'X','x');
				SingleEntry.csFunction = "N/A";
				SingleEntry.csHint = "N/A";
				SingleEntry.csOrdinal.Format( "%s", csOrdinal );
				SingleEntry.csIndex.Format( "%d", nData );
				ExportEntriesArr.Add( SingleEntry );
			}
			ulbase++;
		}
		else
		{
			if( pExportDescriptor->NumberOfNames >= nData )
			{
				if( FALSE == IsBadReadPtr((BYTE*)hMod +  pExportDescriptor->Name,1))
				{ 
					pName = (BYTE*)hMod + nSize;
					name = reinterpret_cast<LPSTR>(pName);
				}
			}
			else
			{
				name = "";
			}
			csName = name;
			if( FALSE != csName.IsEmpty())
			{
				SingleEntry.csFunction = "N/A";
				SingleEntry.csEntryPoint = "";
				
			}
			else
			{
				DWORD dwData = (DWORD)GetProcAddress( hMod,  csName  );
				DWORD dwDiff = dwData - (DWORD)hMod;
				SingleEntry.csEntryPoint.Format("0x%x",dwDiff );
				SingleEntry.csEntryPoint.MakeUpper();
				SingleEntry.csEntryPoint.Replace( 'X','x');
				SingleEntry.csFunction.Format( "%s", csName );
				int nSerach = 0;
				m_MapExport.SetAt( csName, nSerach );
				nHint++;
			}
			int nNextValue = csName.GetLength() + 1;
			nSize = nSize  + nNextValue;
			if(bIntial)
			{
				bIntial = false;
			}
			else
			{
				if( FALSE != csName.IsEmpty())
				{
					SingleEntry.csHint = L"N/A";
					
				}
				else
				{
					SingleEntry.csHint.Format( "%d(0x0%x)",nHint,nHint);
					SingleEntry.csHint.MakeUpper();
					SingleEntry.csHint.Replace( "X", "x" );	
				}
				
				//****Code is not completed due to unavailability of Information.
				SingleEntry.csOrdinal.Format( "%d(0x0%x)",ulbase,ulbase);
				SingleEntry.csOrdinal.MakeUpper();
				SingleEntry.csOrdinal.Replace( "X", "x" );
				SingleEntry.csIndex.Format( "%d", nData );
				ExportEntriesArr.Add( SingleEntry );
				
			}
		}
		 ulbase++;
		dwData+=4;
		nData++;
	}
	FreeLibrary(hMod);
}


bool PEFormatParser::AddString( CString csData )
{
	PEFormatParser::m_ndata++;
	if( 1 >= PEFormatParser::m_ndata)
	{
		m_csdata = "";
		m_csdata += "\\";
		m_csdata += csData;
		CString csUpper = m_csdata;
		csUpper.MakeUpper();
		m_Treeobj.InsertNode( csUpper );
		return true;
	}
	else
	{
		int nPos= 0;
		int nSize = 0;
		if( -1 == m_csdata.Find( csData, 0 ))
		{
			m_csdata += "\\";
			m_csdata += csData;
			CString csUpper = m_csdata;
			csUpper.MakeUpper();
			m_Treeobj.InsertNode( csUpper );
			return true;
		}
		else
		{
			m_csdata += "\\";
			m_csdata += csData;
			CString csUpper = m_csdata;
			csUpper.MakeUpper();
			m_Treeobj.InsertNode( csUpper );
			return false;
		}
	}
}

bool PEFormatParser::DeleteString( CString csData )
{
	CString csStr;
	csStr += "\\";
	csStr += csData;
	int nData = m_csdata.ReverseFind( '\\');
	int nFinalLength = nData + csData.GetLength();
	int Totak = m_csdata.GetLength();
	if( nFinalLength ==  Totak - 1)
	{
		m_csdata = m_csdata.Mid( 0, nData );
		PEFormatParser::m_ndata--;
	}
	else
	{
		return false;
	}
	return true;
}


bool PEFormatParser::GetDLLLoadAddress(  CString csDLLName,  HMODULE& hModDLL,
									     CString& csPathDLLDepend_o )
{
	csPathDLLDepend_o = "";
	if( FALSE == m_csCurrentDirectory.IsEmpty() )
	{
		CString csFullPath = csDLLName;
		if( -1 == csDLLName.Find( "\\", 0 ) )
		{
			csFullPath = m_csCurrentDirectory;
			csFullPath += csDLLName;
		}
		HANDLE hCurrentFile = CreateFile( csFullPath, GENERIC_READ, 
							FILE_SHARE_READ | STANDARD_RIGHTS_REQUIRED,NULL,
							OPEN_EXISTING,
							FILE_ATTRIBUTE_READONLY,
							NULL);
		HFILE hFil;
		if( INVALID_HANDLE_VALUE == hCurrentFile )
		{
			OFSTRUCT ReOpenBuff;
			hFil = OpenFile( csFullPath, & ReOpenBuff, OF_EXIST );
		}
		if( INVALID_HANDLE_VALUE != hCurrentFile ||
			HFILE_ERROR != hFil )
		{
			hModDLL =  LoadLibraryEx( csFullPath, NULL, DONT_RESOLVE_DLL_REFERENCES );
			if( 0 != hModDLL )
			{
				csPathDLLDepend_o = csFullPath;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	if( -1 != csDLLName.Find( "\\", 0 ))
	{
		HANDLE hCurrentFile = CreateFile( csDLLName, GENERIC_READ, 
							FILE_SHARE_READ,NULL,
							OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL,
							NULL);
		if( INVALID_HANDLE_VALUE != hCurrentFile )
		{
			hModDLL = LoadLibraryEx( csDLLName, NULL, DONT_RESOLVE_DLL_REFERENCES ); 
			if( 0 != hModDLL )
			{
				csPathDLLDepend_o = csDLLName;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	
	CString csPath;
	CString csFileName = "\\";
	csFileName += csDLLName;
	DWORD nNum;
	nNum = GetCurrentDirectory( MAX_PATH,csPath.GetBuffer(MAX_PATH));
	csPath.ReleaseBuffer();
	csPath += csFileName;
	HANDLE hFile = CreateFile( csPath, GENERIC_READ, 
							FILE_SHARE_READ,NULL,
							OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL,
							NULL);
	if( INVALID_HANDLE_VALUE == hFile )
	{
		CString csData = _tgetenv( _T( "Path" ));
		int nIndex = 0;
		int nPrev = 0;
		csData.Remove( ' ' );
		csPath = "";

		while( -1 !=( nIndex =  csData.Find( ";", nIndex )))
		{
			csPath = csData.Mid( nPrev, ( nIndex - nPrev ));
			csPath += csFileName;
			BOOL m_bLoaded = FALSE;
			HANDLE hFile = CreateFile( csPath, GENERIC_READ, 
								FILE_SHARE_READ,NULL,
								OPEN_EXISTING,
								FILE_ATTRIBUTE_NORMAL,
								NULL);
			if( INVALID_HANDLE_VALUE != hFile )
			{
				break;
			}
			nPrev = ++nIndex;
		}
	}
	hModDLL = LoadLibraryEx( csPath, NULL, DONT_RESOLVE_DLL_REFERENCES );
	if( 0 != hModDLL )
	{
		csPathDLLDepend_o = csPath;
		return true;
	}
	else
	{
		return false;
	}
}