/*****************************************************************
AR-KJ
This class handles all the functions related to PE format
- Here every code related to PE is written
:- This code can be used and can be reproduced as commercially or
study purpose.
"Sab Ka Malik Ek"
*******************************************************************/
#ifndef	PE_FORMAT_PARSER
#define PE_FORMAT_PARSER

#include "TreeR.h"
#include <afxtempl.h>

struct SINGLE_FUNCT_ENTRY
{
	CString csOrdinal;
	CString csHint;
	CString csFunction;
	CString csEntryPoint;
	CString csIndex;
	bool m_bIsInvalidValid;
};

typedef CArray<SINGLE_FUNCT_ENTRY, SINGLE_FUNCT_ENTRY&> SingleMapEntryArray;

struct DLL_ENTRY
{
	DLL_ENTRY()
	{
	}
	DLL_ENTRY(const DLL_ENTRY& obj )
	{
		this->ArrayExport.Copy( obj.ArrayExport );
		this->ArrayImport.Copy( obj.ArrayImport);
		m_csFullPath = obj.m_csFullPath;
		m_bIsStable = obj.m_bIsStable;
	}
	DLL_ENTRY& operator =( const DLL_ENTRY& obj )
	{
		this->ArrayExport.Copy( obj.ArrayExport );
		this->ArrayImport.Copy( obj.ArrayImport);
		m_csFullPath = obj.m_csFullPath;
		m_bIsStable = obj.m_bIsStable;
		return *this;
	}
	CString m_csFullPath;
	bool m_bIsStable;
	SingleMapEntryArray ArrayExport;
	SingleMapEntryArray ArrayImport;
};

typedef CMap<CString, LPCTSTR, DLL_ENTRY, DLL_ENTRY > MapEntry;
typedef CMap<CString, LPCTSTR, int, int&> SearchMapExport;
/*******************************************************
PE format parser class handled the all the export and import
functions of a DLL.
*******************************************************/
class PEFormatParser
{
public:

	MapEntry m_DataEntry;
	TreeR GetTreeNode( LPCTSTR lpctszModName_i );

private:

	void GetExportData( LPCTSTR lpctszDLLName_i, 
		                SingleMapEntryArray& ExportEntriesArr,
						CString& csPath_o );
	bool GetDLLLoadAddress(  CString csDLLName,  HMODULE& hModDLL,
		                     CString& csPathDLLDepend_o );
	void GetImportAndExportData( LPCTSTR lpctszModName_i );
	bool AddString( CString csData );
	bool DeleteString( CString csData );

private:
	TreeR m_Treeobj;
	CString m_csFirstDLL;
	CString m_csCurrentDirectory;
	SearchMapExport m_MapExport;
	static int m_ndata;
	static CString m_csdata;
};
#endif