/*******************************************
Splitter for 3 views
3 column
2 row
*********************************************/

#ifndef _PE_SPLITTER_WND_H_
#define _PE_SPLITTER_WND_H_


/*****************************
Class for Splitter

Simple splitter
Splits as mentioned below:-

  ******************
  *    *     *     *
  *    *     *     *
  ******************
  *                *
  ******************

******************************/
class PESplitterWnd : public CSplitterWnd
{

public:

	PESplitterWnd();
	virtual ~PESplitterWnd();
	void SetStyle(DWORD dwStyle) {m_dwStyle = dwStyle ; }
	void SetSplitter(CWnd* pParent,CRuntimeClass* pFirstView,CRuntimeClass* pSecView,CRuntimeClass* pThirdView,CRuntimeClass* pFourthView,CCreateContext* pContext);
	void SetFirstViewSize(CSize FirstViewSize)   
	{
		m_FirstViewSize = FirstViewSize;
	}
	void SetSecondViewSize(CSize SecondViewSize) 
	{ 
		m_SecViewSize = SecondViewSize;
	}
	void SetThirdViewSize(CSize ThirdViewSize)   
	{
		m_ThirdViewSize = ThirdViewSize;
	}
	void SetFourthViewSize(CSize FourthViewSize)
	{
		m_FourthViewSize = FourthViewSize;
	}
 
	CSplitterWnd* GetSeconderySplitter() 
	{
		return m_pwndSplitter;
	}

protected:
	CSize m_FirstViewSize;
	CSize m_SecViewSize;
	CSize m_ThirdViewSize;
	CSize m_FourthViewSize;
	CRuntimeClass* m_pFirstView;
	CRuntimeClass* m_pSecView;
	CRuntimeClass* m_pThirdView;
	CRuntimeClass* m_pFourthView;
	CCreateContext* m_pContext;
	DWORD m_dwStyle;

	void SetSplitter(CWnd* pParent);
	CSplitterWnd*  m_pwndSplitter ;



};
#endif // _PE_SPLITTER_WND_H_
