// ProperyView.cpp : implementation file
//

#include "stdafx.h"
#include "ExeInside.h"
#include "ProperyView.h"
#include "DependencyTreeView.h"
#include <WinBase.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CProperyView

IMPLEMENT_DYNCREATE(CProperyView, CListView)

CProperyView::CProperyView()
{
}

CProperyView::~CProperyView()
{
}


BEGIN_MESSAGE_MAP(CProperyView, CListView)
	//{{AFX_MSG_MAP(CProperyView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CProperyView drawing

void CProperyView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CProperyView diagnostics

#ifdef _DEBUG
void CProperyView::AssertValid() const
{
	CListView::AssertValid();
}

void CProperyView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

CPEWatcherDoc* CProperyView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CPEWatcherDoc)));
	return (CPEWatcherDoc*)m_pDocument;
}

/////////////////////////////////////////////////////////////////////////////
// CProperyView message handlers

void CProperyView::OnInitialUpdate()
{
	CListView::OnInitialUpdate();
	GetListCtrl().SetExtendedStyle( LVS_EX_GRIDLINES  );
	GetListCtrl().InsertColumn(0,"Property Name", LVCFMT_LEFT, 300, 100);
	RECT rect;
	this->GetWindowRect(&rect);
	GetListCtrl().InsertColumn(1,"Property Value", LVCFMT_LEFT, rect.right, 100);

}

BOOL CProperyView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style &= ~LVS_TYPEMASK;
    cs.style |= LVS_REPORT;
	return CListView::PreCreateWindow(cs);
}

void CProperyView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	if( UPDATE_EXPORT_IMPORT == lHint )
	{
		GetListCtrl().DeleteAllItems();
		CDependencyTreeView* pTreeView = (CDependencyTreeView*)pSender;
		CString csName = pTreeView->GetFileName();
		SingleMapEntryArray Entryexport;
		if( 0 != GetDocument()->GetExportData(csName, Entryexport ))
		{
			CString csPath = GetDocument()->GetPath();
			if( FALSE == csPath.IsEmpty())
			{
				GetListCtrl().InsertItem( 0, 0 );
				GetListCtrl().SetItemText( 0,0, "Portable Executable(Exe,DLL) File Path" );
				GetListCtrl().SetItemText( 0,1, csPath );

				GetListCtrl().InsertItem( 1, 0 );
				GetListCtrl().SetItemText( 1,0, "Base Address" );
				if(-1 == csPath.Find( ".exe", 0 ))
				{
					HMODULE hMod = LoadLibraryEx( csPath, NULL, DONT_RESOLVE_DLL_REFERENCES );
					DWORD dwLoadAdd  = (DWORD)hMod;
					FreeLibrary( hMod );
					CString csFile;
					csFile.Format( "0x%x", dwLoadAdd );
					csFile.MakeUpper();
					csFile.Replace( "X", "x");
					GetListCtrl().SetItemText( 1,1, csFile );
				}
				HANDLE hFile =hFile = CreateFile( csPath, GENERIC_READ, FILE_SHARE_READ,
												  NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL,
												  NULL);
				DWORD dwFileSize = ::GetFileSize( hFile, NULL );
				GetListCtrl().InsertItem( 2, 0 );
				GetListCtrl().SetItemText( 2,0, "File Size" );
				CString csFileSize;
				csFileSize.Format( "%d bytes or %d KB", dwFileSize, (dwFileSize/1024) );
				GetListCtrl().SetItemText( 2,1, csFileSize );
				BY_HANDLE_FILE_INFORMATION FileInformation;
				GetFileInformationByHandle( hFile, &FileInformation );
				SYSTEMTIME SystemFile;
				FileTimeToSystemTime( &FileInformation.ftCreationTime, &SystemFile );
				GetListCtrl().InsertItem( 2, 0 );
				GetListCtrl().SetItemText( 2,0, "File Creation Time(mm-dd-yy):(Hours-Minutes-Seconds)" );
				CString csFileCreationDate;
				csFileCreationDate.Format( "(%d-%d-%d):(%d Hrs-%d Mnts-%d Secs)", SystemFile.wMonth,
					                       SystemFile.wDay, SystemFile.wYear,
										   SystemFile.wHour,SystemFile.wMinute,
										   SystemFile.wSecond);
				GetListCtrl().SetItemText( 2,1, csFileCreationDate );
				CloseHandle( hFile );

			}
		}
	}

}
